package fit.growth;

/**
 * X = A * ( 1 - exp(-k * t) ) ^ m. _growthParams[0]: k; _growthParams[1]: m;
 */
public class Growth_Anamorphic implements Growth {

    @Override
    public int paramLen() {
        return 2;
    }

    @Override
    public double calcXAtT(double _t, double _Asymptote, double... _growthParams) {
        return _Asymptote * Math.pow(1 - Math.exp(-_growthParams[0] * _t), _growthParams[1]);
    }

    @Override
    public double log_dAdX(double _t, double _Asymptote, double... _growthParams) {
        return -_growthParams[1] * Math.log(1 - Math.exp(-_growthParams[0] * _t));
    }

    //For anamorphic model, the asymptote can be provided.
    @Override
    public double getAsymptote(double _t, double _x, double... _growthParams) {
        return _x / Math.pow(1 - Math.exp(-_growthParams[0] * _t), _growthParams[1]);
    }

}
