package fit.growth;

/**
 * X = A * ( 1 - exp(-k * t) ) ^ m, k = a * (A ^ b). _growthParams[0]: a; _growthParams[1]: m; _growthParams[2]: b;
 */
public class Growth_Polymorphic implements Growth {

    static {
        System.out.println("IMPORTANT NOTE: Growth_PowerK uses scaled asymptote value with 25. Modify the third parameter after estimation.");
    }

    /**
     * This value is used for preventing overflow of asymptote^b.
     */
    public final double NORMALIZE_HEIGHT = 1 / 25.0;

    @Override
    public int paramLen() {
        return 3;
    }

    @Override
    public double calcXAtT(double _t, double _Asymptote, double... _growthParams) {
        return _Asymptote * Math.pow(1 - Math.exp(-(_growthParams[0] * Math.pow(_Asymptote * NORMALIZE_HEIGHT, _growthParams[2])) * _t), _growthParams[1]);
    }

    @Override
    public double log_dAdX(double _t, double _Asymptote, double... _growthParams) {
        double e = Math.exp(-(_growthParams[0] * Math.pow(_Asymptote * NORMALIZE_HEIGHT, _growthParams[2])) * _t);
        return -Math.log(Math.pow(_Asymptote * NORMALIZE_HEIGHT, _growthParams[2]) * _t * _growthParams[0] * _growthParams[1] * _growthParams[2]
                * Math.pow(1 - e, _growthParams[1] - 1) * e + Math.pow(1 - e, _growthParams[1]));
    }

}
